// GENERATED CODE - DO NOT MODIFY BY HAND

part of 'database.dart';

// **************************************************************************
// FloorGenerator
// **************************************************************************

// ignore: avoid_classes_with_only_static_members
class $FloorERPDBContext {
  /// Creates a database builder for a persistent database.
  /// Once a database is built, you should keep a reference to it and re-use it.
  static _$ERPDBContextBuilder databaseBuilder(String name) =>
      _$ERPDBContextBuilder(name);

  /// Creates a database builder for an in memory database.
  /// Information stored in an in memory database disappears when the process is killed.
  /// Once a database is built, you should keep a reference to it and re-use it.
  static _$ERPDBContextBuilder inMemoryDatabaseBuilder() =>
      _$ERPDBContextBuilder(null);
}

class _$ERPDBContextBuilder {
  _$ERPDBContextBuilder(this.name);

  final String? name;

  final List<Migration> _migrations = [];

  Callback? _callback;

  /// Adds migrations to the builder.
  _$ERPDBContextBuilder addMigrations(List<Migration> migrations) {
    _migrations.addAll(migrations);
    return this;
  }

  /// Adds a database [Callback] to the builder.
  _$ERPDBContextBuilder addCallback(Callback callback) {
    _callback = callback;
    return this;
  }

  /// Creates the database and initializes it.
  Future<ERPDBContext> build() async {
    final path = name != null
        ? await sqfliteDatabaseFactory.getDatabasePath(name!)
        : ':memory:';
    final database = _$ERPDBContext();
    database.database = await database.open(
      path,
      _migrations,
      _callback,
    );
    return database;
  }
}

class _$ERPDBContext extends ERPDBContext {
  _$ERPDBContext([StreamController<String>? listener]) {
    changeListener = listener ?? StreamController<String>.broadcast();
  }

  BranchDbSet? _branchInstance;

  UserDbSet? _userInstance;

  UserRoleDbSet? _userRoleInstance;

  PermissionDbSet? _permissionInstance;

  BranchUserDbSet? _branchUserInstance;

  BranchUserPermissionDbSet? _branchUserPermissionInstance;

  SessionDbSet? _sessionInstance;

  DeviceDbSet? _deviceInstance;

  AccountGroupDbSet? _accountGroupInstance;

  AccountTypeDbSet? _accountTypeInstance;

  AccountLevelDbSet? _accountLevelInstance;

  CurrencyDbSet? _currencyInstance;

  AccountDbSet? _accountInstance;

  AccountCurrencyDbSet? _accountCurrencyInstance;

  ReceiptTypeDbSet? _receiptTypeInstance;

  ReceiptDbSet? _receiptInstance;

  ReceiptDetailDbSet? _receiptDetailInstance;

  StoreDbSet? _storeInstance;

  ProductCatagoryDbSet? _productCatagoryInstance;

  MeasureUnitDbSet? _measureUnitInstance;

  ProductTypeDbSet? _productTypeInstance;

  ProductDbSet? _productInstance;

  ProductMeasureDbSet? _productMeasureInstance;

  ProductStorageDbSet? _productStorageInstance;

  Future<sqflite.Database> open(
    String path,
    List<Migration> migrations, [
    Callback? callback,
  ]) async {
    final databaseOptions = sqflite.OpenDatabaseOptions(
      version: 1,
      onConfigure: (database) async {
        await database.execute('PRAGMA foreign_keys = ON');
        await callback?.onConfigure?.call(database);
      },
      onOpen: (database) async {
        await callback?.onOpen?.call(database);
      },
      onUpgrade: (database, startVersion, endVersion) async {
        await MigrationAdapter.runMigrations(
            database, startVersion, endVersion, migrations);

        await callback?.onUpgrade?.call(database, startVersion, endVersion);
      },
      onCreate: (database, version) async {
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `branch` (`description` TEXT, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `user` (`name` TEXT NOT NULL, `create_at` INTEGER NOT NULL, `session_id` INTEGER NOT NULL, `id` INTEGER NOT NULL, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `user_role` (`description` TEXT, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `branch_user` (`user_id` INTEGER NOT NULL, `session_id` INTEGER NOT NULL, `branch_id` INTEGER NOT NULL, `role_id` INTEGER NOT NULL, `status` INTEGER NOT NULL, FOREIGN KEY (`role_id`) REFERENCES `user_role` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`user_id`) REFERENCES `user` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`branch_id`) REFERENCES `branch` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`user_id`, `branch_id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `permission` (`type_id` INTEGER NOT NULL, `up_id` INTEGER, `up_status` INTEGER NOT NULL, `description` TEXT, `updateAt` INTEGER NOT NULL, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, FOREIGN KEY (`up_id`) REFERENCES `permission` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `branch_user_permission` (`branch_id` INTEGER NOT NULL, `user_id` INTEGER NOT NULL, `session_id` INTEGER NOT NULL, `permission_id` INTEGER NOT NULL, `status` INTEGER NOT NULL, `permission_status` INTEGER NOT NULL, FOREIGN KEY (`branch_id`) REFERENCES `branch` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`user_id`) REFERENCES `user` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`permission_id`) REFERENCES `permission` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`branch_id`, `user_id`, `permission_id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `session` (`device_id` TEXT NOT NULL, `start_at` INTEGER NOT NULL, `last_use_at` INTEGER NOT NULL, `user_id` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, FOREIGN KEY (`device_id`) REFERENCES `device` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`user_id`) REFERENCES `user` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `device` (`id` TEXT NOT NULL, `status` INTEGER NOT NULL, `description` TEXT, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `currency` (`name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `account_type` (`description` TEXT, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `account_level` (`description` TEXT, `up_id` INTEGER, `count` INTEGER NOT NULL, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, FOREIGN KEY (`up_id`) REFERENCES `account_level` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `account_group` (`description` TEXT, `up_id` INTEGER, `session_id` INTEGER NOT NULL, `user_id` INTEGER NOT NULL, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, FOREIGN KEY (`up_id`) REFERENCES `account_group` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `account` (`description` TEXT, `branch_id` INTEGER NOT NULL, `type_id` INTEGER NOT NULL, `level_id` INTEGER NOT NULL, `up_id` INTEGER, `group_id` INTEGER, `session_id` INTEGER NOT NULL, `user_id` INTEGER NOT NULL, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, FOREIGN KEY (`branch_id`) REFERENCES `branch` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`type_id`) REFERENCES `account_type` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`level_id`) REFERENCES `account_level` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`group_id`) REFERENCES `account_group` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`up_id`) REFERENCES `account` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`branch_id`, `id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `account_currency` (`branch_id` INTEGER NOT NULL, `account_id` INTEGER NOT NULL, `currency_id` INTEGER NOT NULL, `price` REAL NOT NULL, `status` INTEGER NOT NULL, `create_at` INTEGER NOT NULL, `session_id` INTEGER NOT NULL, `user_id` INTEGER NOT NULL, FOREIGN KEY (`branch_id`) REFERENCES `branch` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`account_id`) REFERENCES `account` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`currency_id`) REFERENCES `currency` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`branch_id`, `account_id`, `currency_id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `receipt_type` (`description` TEXT, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `receipt` (`global_no` INTEGER NOT NULL, `status` INTEGER NOT NULL, `description` TEXT, `branch_id` INTEGER NOT NULL, `type_id` INTEGER NOT NULL, `serial_no` INTEGER, `create_at` INTEGER NOT NULL, `session_id` INTEGER NOT NULL, `user_id` INTEGER NOT NULL, `id` INTEGER NOT NULL, FOREIGN KEY (`branch_id`) REFERENCES `branch` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`type_id`) REFERENCES `receipt_type` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`branch_id`, `type_id`, `id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `receipt_detail` (`description` TEXT, `branch_id` INTEGER NOT NULL, `type_id` INTEGER NOT NULL, `receipt_id` INTEGER NOT NULL, `account_id` INTEGER NOT NULL, `currency_id` INTEGER NOT NULL, `price` REAL NOT NULL, `session_id` INTEGER NOT NULL, `user_id` INTEGER NOT NULL, FOREIGN KEY (`branch_id`) REFERENCES `branch` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`type_id`) REFERENCES `receipt_type` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`receipt_id`) REFERENCES `receipt` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`account_id`) REFERENCES `account` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`currency_id`) REFERENCES `currency` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`branch_id`, `type_id`, `receipt_id`, `account_id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `product_catagory` (`description` TEXT, `user_id` INTEGER NOT NULL, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `product_type` (`description` TEXT, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `measure_unit` (`description` TEXT, `up_id` INTEGER, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, FOREIGN KEY (`up_id`) REFERENCES `measure_unit` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `person` (`description` TEXT, `branch_id` INTEGER NOT NULL, `user_id` INTEGER NOT NULL, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, FOREIGN KEY (`branch_id`) REFERENCES `branch` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `product` (`catagory_id` INTEGER NOT NULL, `type_id` INTEGER NOT NULL, `measure_unit_id` INTEGER, `description` TEXT, `second_name` TEXT, `images` TEXT, `has_expire_date` INTEGER NOT NULL, `age_days` INTEGER, `user_id` INTEGER NOT NULL, `name` TEXT NOT NULL, `status` INTEGER NOT NULL, `id` INTEGER NOT NULL, FOREIGN KEY (`catagory_id`) REFERENCES `product_catagory` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`type_id`) REFERENCES `product_type` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`measure_unit_id`) REFERENCES `measure_unit` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `product_measure` (`product_id` INTEGER NOT NULL, `measure_unit_id` INTEGER NOT NULL, `currency_id` INTEGER NOT NULL, `price` REAL NOT NULL, `status` INTEGER NOT NULL, `barcode` TEXT, `min_count` INTEGER NOT NULL, `max_count` INTEGER, `notify_count` INTEGER, `session_id` INTEGER NOT NULL, `user_id` INTEGER NOT NULL, FOREIGN KEY (`product_id`) REFERENCES `product` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`currency_id`) REFERENCES `currency` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`measure_unit_id`) REFERENCES `measure_unit` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`product_id`, `measure_unit_id`, `currency_id`))');
        await database.execute(
            'CREATE TABLE IF NOT EXISTS `product_storage` (`branch_id` INTEGER NOT NULL, `product_id` INTEGER NOT NULL, `measure_unit_id` INTEGER NOT NULL, `currency_id` INTEGER NOT NULL, `store_id` INTEGER NOT NULL, `price` REAL NOT NULL, `expired_at` INTEGER NOT NULL, `produced_at` INTEGER, `count` INTEGER NOT NULL, FOREIGN KEY (`branch_id`) REFERENCES `branch` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`store_id`) REFERENCES `person` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`product_id`) REFERENCES `product` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`measure_unit_id`) REFERENCES `measure_unit` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, FOREIGN KEY (`currency_id`) REFERENCES `currency` (`id`) ON UPDATE NO ACTION ON DELETE NO ACTION, PRIMARY KEY (`branch_id`, `product_id`, `measure_unit_id`, `currency_id`, `store_id`, `price`, `expired_at`))');

        await callback?.onCreate?.call(database, version);
      },
    );
    return sqfliteDatabaseFactory.openDatabase(path, options: databaseOptions);
  }

  @override
  BranchDbSet get branch {
    return _branchInstance ??= _$BranchDbSet(database, changeListener);
  }

  @override
  UserDbSet get user {
    return _userInstance ??= _$UserDbSet(database, changeListener);
  }

  @override
  UserRoleDbSet get userRole {
    return _userRoleInstance ??= _$UserRoleDbSet(database, changeListener);
  }

  @override
  PermissionDbSet get permission {
    return _permissionInstance ??= _$PermissionDbSet(database, changeListener);
  }

  @override
  BranchUserDbSet get branchUser {
    return _branchUserInstance ??= _$BranchUserDbSet(database, changeListener);
  }

  @override
  BranchUserPermissionDbSet get branchUserPermission {
    return _branchUserPermissionInstance ??=
        _$BranchUserPermissionDbSet(database, changeListener);
  }

  @override
  SessionDbSet get session {
    return _sessionInstance ??= _$SessionDbSet(database, changeListener);
  }

  @override
  DeviceDbSet get device {
    return _deviceInstance ??= _$DeviceDbSet(database, changeListener);
  }

  @override
  AccountGroupDbSet get accountGroup {
    return _accountGroupInstance ??=
        _$AccountGroupDbSet(database, changeListener);
  }

  @override
  AccountTypeDbSet get accountType {
    return _accountTypeInstance ??=
        _$AccountTypeDbSet(database, changeListener);
  }

  @override
  AccountLevelDbSet get accountLevel {
    return _accountLevelInstance ??=
        _$AccountLevelDbSet(database, changeListener);
  }

  @override
  CurrencyDbSet get currency {
    return _currencyInstance ??= _$CurrencyDbSet(database, changeListener);
  }

  @override
  AccountDbSet get account {
    return _accountInstance ??= _$AccountDbSet(database, changeListener);
  }

  @override
  AccountCurrencyDbSet get accountCurrency {
    return _accountCurrencyInstance ??=
        _$AccountCurrencyDbSet(database, changeListener);
  }

  @override
  ReceiptTypeDbSet get receiptType {
    return _receiptTypeInstance ??=
        _$ReceiptTypeDbSet(database, changeListener);
  }

  @override
  ReceiptDbSet get receipt {
    return _receiptInstance ??= _$ReceiptDbSet(database, changeListener);
  }

  @override
  ReceiptDetailDbSet get receiptDetail {
    return _receiptDetailInstance ??=
        _$ReceiptDetailDbSet(database, changeListener);
  }

  @override
  StoreDbSet get store {
    return _storeInstance ??= _$StoreDbSet(database, changeListener);
  }

  @override
  ProductCatagoryDbSet get productCatagory {
    return _productCatagoryInstance ??=
        _$ProductCatagoryDbSet(database, changeListener);
  }

  @override
  MeasureUnitDbSet get measureUnit {
    return _measureUnitInstance ??=
        _$MeasureUnitDbSet(database, changeListener);
  }

  @override
  ProductTypeDbSet get productType {
    return _productTypeInstance ??=
        _$ProductTypeDbSet(database, changeListener);
  }

  @override
  ProductDbSet get product {
    return _productInstance ??= _$ProductDbSet(database, changeListener);
  }

  @override
  ProductMeasureDbSet get productMeasure {
    return _productMeasureInstance ??=
        _$ProductMeasureDbSet(database, changeListener);
  }

  @override
  ProductStorageDbSet get productStorage {
    return _productStorageInstance ??=
        _$ProductStorageDbSet(database, changeListener);
  }
}

class _$BranchDbSet extends BranchDbSet {
  _$BranchDbSet(
    this.database,
    this.changeListener,
  )   : _branchModelInsertionAdapter = InsertionAdapter(
            database,
            'branch',
            (BranchModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _branchModelUpdateAdapter = UpdateAdapter(
            database,
            'branch',
            ['id'],
            (BranchModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _branchModelDeletionAdapter = DeletionAdapter(
            database,
            'branch',
            ['id'],
            (BranchModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<BranchModel> _branchModelInsertionAdapter;

  final UpdateAdapter<BranchModel> _branchModelUpdateAdapter;

  final DeletionAdapter<BranchModel> _branchModelDeletionAdapter;

  @override
  Future<void> insertRow(BranchModel row) async {
    await _branchModelInsertionAdapter.insert(row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<BranchModel> rows) {
    return _branchModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(BranchModel row) async {
    await _branchModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<BranchModel> rows) {
    return _branchModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(BranchModel row) async {
    await _branchModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<BranchModel> rows) {
    return _branchModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$UserDbSet extends UserDbSet {
  _$UserDbSet(
    this.database,
    this.changeListener,
  )   : _userModelInsertionAdapter = InsertionAdapter(
            database,
            'user',
            (UserModel item) => <String, Object?>{
                  'name': item.name,
                  'create_at': _dateTimeConverter.encode(item.createAt),
                  'session_id': item.sessionId,
                  'id': item.id
                }),
        _userModelUpdateAdapter = UpdateAdapter(
            database,
            'user',
            ['id'],
            (UserModel item) => <String, Object?>{
                  'name': item.name,
                  'create_at': _dateTimeConverter.encode(item.createAt),
                  'session_id': item.sessionId,
                  'id': item.id
                }),
        _userModelDeletionAdapter = DeletionAdapter(
            database,
            'user',
            ['id'],
            (UserModel item) => <String, Object?>{
                  'name': item.name,
                  'create_at': _dateTimeConverter.encode(item.createAt),
                  'session_id': item.sessionId,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<UserModel> _userModelInsertionAdapter;

  final UpdateAdapter<UserModel> _userModelUpdateAdapter;

  final DeletionAdapter<UserModel> _userModelDeletionAdapter;

  @override
  Future<void> insertRow(UserModel row) async {
    await _userModelInsertionAdapter.insert(row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<UserModel> rows) {
    return _userModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(UserModel row) async {
    await _userModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<UserModel> rows) {
    return _userModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(UserModel row) async {
    await _userModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<UserModel> rows) {
    return _userModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$UserRoleDbSet extends UserRoleDbSet {
  _$UserRoleDbSet(
    this.database,
    this.changeListener,
  )   : _userRoleModelInsertionAdapter = InsertionAdapter(
            database,
            'user_role',
            (UserRoleModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _userRoleModelUpdateAdapter = UpdateAdapter(
            database,
            'user_role',
            ['id'],
            (UserRoleModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _userRoleModelDeletionAdapter = DeletionAdapter(
            database,
            'user_role',
            ['id'],
            (UserRoleModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<UserRoleModel> _userRoleModelInsertionAdapter;

  final UpdateAdapter<UserRoleModel> _userRoleModelUpdateAdapter;

  final DeletionAdapter<UserRoleModel> _userRoleModelDeletionAdapter;

  @override
  Future<void> insertRow(UserRoleModel row) async {
    await _userRoleModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<UserRoleModel> rows) {
    return _userRoleModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(UserRoleModel row) async {
    await _userRoleModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<UserRoleModel> rows) {
    return _userRoleModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(UserRoleModel row) async {
    await _userRoleModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<UserRoleModel> rows) {
    return _userRoleModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$PermissionDbSet extends PermissionDbSet {
  _$PermissionDbSet(
    this.database,
    this.changeListener,
  )   : _permissionModelInsertionAdapter = InsertionAdapter(
            database,
            'permission',
            (PermissionModel item) => <String, Object?>{
                  'type_id': item.typeId,
                  'up_id': item.upId,
                  'up_status': item.upStatus ? 1 : 0,
                  'description': item.description,
                  'updateAt': _dateTimeConverter.encode(item.updateAt),
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _permissionModelUpdateAdapter = UpdateAdapter(
            database,
            'permission',
            ['id'],
            (PermissionModel item) => <String, Object?>{
                  'type_id': item.typeId,
                  'up_id': item.upId,
                  'up_status': item.upStatus ? 1 : 0,
                  'description': item.description,
                  'updateAt': _dateTimeConverter.encode(item.updateAt),
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _permissionModelDeletionAdapter = DeletionAdapter(
            database,
            'permission',
            ['id'],
            (PermissionModel item) => <String, Object?>{
                  'type_id': item.typeId,
                  'up_id': item.upId,
                  'up_status': item.upStatus ? 1 : 0,
                  'description': item.description,
                  'updateAt': _dateTimeConverter.encode(item.updateAt),
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<PermissionModel> _permissionModelInsertionAdapter;

  final UpdateAdapter<PermissionModel> _permissionModelUpdateAdapter;

  final DeletionAdapter<PermissionModel> _permissionModelDeletionAdapter;

  @override
  Future<void> insertRow(PermissionModel row) async {
    await _permissionModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<PermissionModel> rows) {
    return _permissionModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(PermissionModel row) async {
    await _permissionModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<PermissionModel> rows) {
    return _permissionModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(PermissionModel row) async {
    await _permissionModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<PermissionModel> rows) {
    return _permissionModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$BranchUserDbSet extends BranchUserDbSet {
  _$BranchUserDbSet(
    this.database,
    this.changeListener,
  )   : _branchUserModelInsertionAdapter = InsertionAdapter(
            database,
            'branch_user',
            (BranchUserModel item) => <String, Object?>{
                  'user_id': item.userId,
                  'session_id': item.sessionId,
                  'branch_id': item.branchId,
                  'role_id': item.roleId,
                  'status': item.status ? 1 : 0
                }),
        _branchUserModelUpdateAdapter = UpdateAdapter(
            database,
            'branch_user',
            ['user_id', 'branch_id'],
            (BranchUserModel item) => <String, Object?>{
                  'user_id': item.userId,
                  'session_id': item.sessionId,
                  'branch_id': item.branchId,
                  'role_id': item.roleId,
                  'status': item.status ? 1 : 0
                }),
        _branchUserModelDeletionAdapter = DeletionAdapter(
            database,
            'branch_user',
            ['user_id', 'branch_id'],
            (BranchUserModel item) => <String, Object?>{
                  'user_id': item.userId,
                  'session_id': item.sessionId,
                  'branch_id': item.branchId,
                  'role_id': item.roleId,
                  'status': item.status ? 1 : 0
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<BranchUserModel> _branchUserModelInsertionAdapter;

  final UpdateAdapter<BranchUserModel> _branchUserModelUpdateAdapter;

  final DeletionAdapter<BranchUserModel> _branchUserModelDeletionAdapter;

  @override
  Future<void> insertRow(BranchUserModel row) async {
    await _branchUserModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<BranchUserModel> rows) {
    return _branchUserModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(BranchUserModel row) async {
    await _branchUserModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<BranchUserModel> rows) {
    return _branchUserModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(BranchUserModel row) async {
    await _branchUserModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<BranchUserModel> rows) {
    return _branchUserModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$BranchUserPermissionDbSet extends BranchUserPermissionDbSet {
  _$BranchUserPermissionDbSet(
    this.database,
    this.changeListener,
  )   : _branchUserPermissionModelInsertionAdapter = InsertionAdapter(
            database,
            'branch_user_permission',
            (BranchUserPermissionModel item) => <String, Object?>{
                  'branch_id': item.branchId,
                  'user_id': item.userId,
                  'session_id': item.sessionId,
                  'permission_id': item.permissionId,
                  'status': item.status ? 1 : 0,
                  'permission_status': item.permissionStatus ? 1 : 0
                }),
        _branchUserPermissionModelUpdateAdapter = UpdateAdapter(
            database,
            'branch_user_permission',
            ['branch_id', 'user_id', 'permission_id'],
            (BranchUserPermissionModel item) => <String, Object?>{
                  'branch_id': item.branchId,
                  'user_id': item.userId,
                  'session_id': item.sessionId,
                  'permission_id': item.permissionId,
                  'status': item.status ? 1 : 0,
                  'permission_status': item.permissionStatus ? 1 : 0
                }),
        _branchUserPermissionModelDeletionAdapter = DeletionAdapter(
            database,
            'branch_user_permission',
            ['branch_id', 'user_id', 'permission_id'],
            (BranchUserPermissionModel item) => <String, Object?>{
                  'branch_id': item.branchId,
                  'user_id': item.userId,
                  'session_id': item.sessionId,
                  'permission_id': item.permissionId,
                  'status': item.status ? 1 : 0,
                  'permission_status': item.permissionStatus ? 1 : 0
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<BranchUserPermissionModel>
      _branchUserPermissionModelInsertionAdapter;

  final UpdateAdapter<BranchUserPermissionModel>
      _branchUserPermissionModelUpdateAdapter;

  final DeletionAdapter<BranchUserPermissionModel>
      _branchUserPermissionModelDeletionAdapter;

  @override
  Future<void> insertRow(BranchUserPermissionModel row) async {
    await _branchUserPermissionModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<BranchUserPermissionModel> rows) {
    return _branchUserPermissionModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(BranchUserPermissionModel row) async {
    await _branchUserPermissionModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<BranchUserPermissionModel> rows) {
    return _branchUserPermissionModelUpdateAdapter
        .updateListAndReturnChangedRows(rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(BranchUserPermissionModel row) async {
    await _branchUserPermissionModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<BranchUserPermissionModel> rows) {
    return _branchUserPermissionModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

class _$SessionDbSet extends SessionDbSet {
  _$SessionDbSet(
    this.database,
    this.changeListener,
  )   : _sessionModelInsertionAdapter = InsertionAdapter(
            database,
            'session',
            (SessionModel item) => <String, Object?>{
                  'device_id': item.deviceId,
                  'start_at': _dateTimeConverter.encode(item.startAt),
                  'last_use_at': _dateTimeConverter.encode(item.lastUseAt),
                  'user_id': item.userId,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _sessionModelUpdateAdapter = UpdateAdapter(
            database,
            'session',
            ['id'],
            (SessionModel item) => <String, Object?>{
                  'device_id': item.deviceId,
                  'start_at': _dateTimeConverter.encode(item.startAt),
                  'last_use_at': _dateTimeConverter.encode(item.lastUseAt),
                  'user_id': item.userId,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _sessionModelDeletionAdapter = DeletionAdapter(
            database,
            'session',
            ['id'],
            (SessionModel item) => <String, Object?>{
                  'device_id': item.deviceId,
                  'start_at': _dateTimeConverter.encode(item.startAt),
                  'last_use_at': _dateTimeConverter.encode(item.lastUseAt),
                  'user_id': item.userId,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<SessionModel> _sessionModelInsertionAdapter;

  final UpdateAdapter<SessionModel> _sessionModelUpdateAdapter;

  final DeletionAdapter<SessionModel> _sessionModelDeletionAdapter;

  @override
  Future<void> insertRow(SessionModel row) async {
    await _sessionModelInsertionAdapter.insert(row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<SessionModel> rows) {
    return _sessionModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(SessionModel row) async {
    await _sessionModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<SessionModel> rows) {
    return _sessionModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(SessionModel row) async {
    await _sessionModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<SessionModel> rows) {
    return _sessionModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$DeviceDbSet extends DeviceDbSet {
  _$DeviceDbSet(
    this.database,
    this.changeListener,
  )   : _deviceModelInsertionAdapter = InsertionAdapter(
            database,
            'device',
            (DeviceModel item) => <String, Object?>{
                  'id': item.id,
                  'status': item.status ? 1 : 0,
                  'description': item.description
                }),
        _deviceModelUpdateAdapter = UpdateAdapter(
            database,
            'device',
            ['id'],
            (DeviceModel item) => <String, Object?>{
                  'id': item.id,
                  'status': item.status ? 1 : 0,
                  'description': item.description
                }),
        _deviceModelDeletionAdapter = DeletionAdapter(
            database,
            'device',
            ['id'],
            (DeviceModel item) => <String, Object?>{
                  'id': item.id,
                  'status': item.status ? 1 : 0,
                  'description': item.description
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<DeviceModel> _deviceModelInsertionAdapter;

  final UpdateAdapter<DeviceModel> _deviceModelUpdateAdapter;

  final DeletionAdapter<DeviceModel> _deviceModelDeletionAdapter;

  @override
  Future<void> insertRow(DeviceModel row) async {
    await _deviceModelInsertionAdapter.insert(row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<DeviceModel> rows) {
    return _deviceModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(DeviceModel row) async {
    await _deviceModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<DeviceModel> rows) {
    return _deviceModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(DeviceModel row) async {
    await _deviceModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<DeviceModel> rows) {
    return _deviceModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$AccountGroupDbSet extends AccountGroupDbSet {
  _$AccountGroupDbSet(
    this.database,
    this.changeListener,
  )   : _accountGroupModelInsertionAdapter = InsertionAdapter(
            database,
            'account_group',
            (AccountGroupModel item) => <String, Object?>{
                  'description': item.description,
                  'up_id': item.upId,
                  'session_id': item.sessionId,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _accountGroupModelUpdateAdapter = UpdateAdapter(
            database,
            'account_group',
            ['id'],
            (AccountGroupModel item) => <String, Object?>{
                  'description': item.description,
                  'up_id': item.upId,
                  'session_id': item.sessionId,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _accountGroupModelDeletionAdapter = DeletionAdapter(
            database,
            'account_group',
            ['id'],
            (AccountGroupModel item) => <String, Object?>{
                  'description': item.description,
                  'up_id': item.upId,
                  'session_id': item.sessionId,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<AccountGroupModel> _accountGroupModelInsertionAdapter;

  final UpdateAdapter<AccountGroupModel> _accountGroupModelUpdateAdapter;

  final DeletionAdapter<AccountGroupModel> _accountGroupModelDeletionAdapter;

  @override
  Future<void> insertRow(AccountGroupModel row) async {
    await _accountGroupModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<AccountGroupModel> rows) {
    return _accountGroupModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(AccountGroupModel row) async {
    await _accountGroupModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<AccountGroupModel> rows) {
    return _accountGroupModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(AccountGroupModel row) async {
    await _accountGroupModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<AccountGroupModel> rows) {
    return _accountGroupModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

class _$AccountTypeDbSet extends AccountTypeDbSet {
  _$AccountTypeDbSet(
    this.database,
    this.changeListener,
  )   : _accountTypeModelInsertionAdapter = InsertionAdapter(
            database,
            'account_type',
            (AccountTypeModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _accountTypeModelUpdateAdapter = UpdateAdapter(
            database,
            'account_type',
            ['id'],
            (AccountTypeModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _accountTypeModelDeletionAdapter = DeletionAdapter(
            database,
            'account_type',
            ['id'],
            (AccountTypeModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<AccountTypeModel> _accountTypeModelInsertionAdapter;

  final UpdateAdapter<AccountTypeModel> _accountTypeModelUpdateAdapter;

  final DeletionAdapter<AccountTypeModel> _accountTypeModelDeletionAdapter;

  @override
  Future<void> insertRow(AccountTypeModel row) async {
    await _accountTypeModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<AccountTypeModel> rows) {
    return _accountTypeModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(AccountTypeModel row) async {
    await _accountTypeModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<AccountTypeModel> rows) {
    return _accountTypeModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(AccountTypeModel row) async {
    await _accountTypeModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<AccountTypeModel> rows) {
    return _accountTypeModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

class _$AccountLevelDbSet extends AccountLevelDbSet {
  _$AccountLevelDbSet(
    this.database,
    this.changeListener,
  )   : _accountLevelModelInsertionAdapter = InsertionAdapter(
            database,
            'account_level',
            (AccountLevelModel item) => <String, Object?>{
                  'description': item.description,
                  'up_id': item.upId,
                  'count': item.count,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _accountLevelModelUpdateAdapter = UpdateAdapter(
            database,
            'account_level',
            ['id'],
            (AccountLevelModel item) => <String, Object?>{
                  'description': item.description,
                  'up_id': item.upId,
                  'count': item.count,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _accountLevelModelDeletionAdapter = DeletionAdapter(
            database,
            'account_level',
            ['id'],
            (AccountLevelModel item) => <String, Object?>{
                  'description': item.description,
                  'up_id': item.upId,
                  'count': item.count,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<AccountLevelModel> _accountLevelModelInsertionAdapter;

  final UpdateAdapter<AccountLevelModel> _accountLevelModelUpdateAdapter;

  final DeletionAdapter<AccountLevelModel> _accountLevelModelDeletionAdapter;

  @override
  Future<void> insertRow(AccountLevelModel row) async {
    await _accountLevelModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<AccountLevelModel> rows) {
    return _accountLevelModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(AccountLevelModel row) async {
    await _accountLevelModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<AccountLevelModel> rows) {
    return _accountLevelModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(AccountLevelModel row) async {
    await _accountLevelModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<AccountLevelModel> rows) {
    return _accountLevelModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

class _$CurrencyDbSet extends CurrencyDbSet {
  _$CurrencyDbSet(
    this.database,
    this.changeListener,
  )   : _currencyModelInsertionAdapter = InsertionAdapter(
            database,
            'currency',
            (CurrencyModel item) => <String, Object?>{
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _currencyModelUpdateAdapter = UpdateAdapter(
            database,
            'currency',
            ['id'],
            (CurrencyModel item) => <String, Object?>{
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _currencyModelDeletionAdapter = DeletionAdapter(
            database,
            'currency',
            ['id'],
            (CurrencyModel item) => <String, Object?>{
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<CurrencyModel> _currencyModelInsertionAdapter;

  final UpdateAdapter<CurrencyModel> _currencyModelUpdateAdapter;

  final DeletionAdapter<CurrencyModel> _currencyModelDeletionAdapter;

  @override
  Future<void> insertRow(CurrencyModel row) async {
    await _currencyModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<CurrencyModel> rows) {
    return _currencyModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(CurrencyModel row) async {
    await _currencyModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<CurrencyModel> rows) {
    return _currencyModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(CurrencyModel row) async {
    await _currencyModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<CurrencyModel> rows) {
    return _currencyModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$AccountDbSet extends AccountDbSet {
  _$AccountDbSet(
    this.database,
    this.changeListener,
  )   : _accountModelInsertionAdapter = InsertionAdapter(
            database,
            'account',
            (AccountModel item) => <String, Object?>{
                  'description': item.description,
                  'branch_id': item.branchId,
                  'type_id': item.typeId,
                  'level_id': item.levelId,
                  'up_id': item.upId,
                  'group_id': item.groupId,
                  'session_id': item.sessionId,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _accountModelUpdateAdapter = UpdateAdapter(
            database,
            'account',
            ['branch_id', 'id'],
            (AccountModel item) => <String, Object?>{
                  'description': item.description,
                  'branch_id': item.branchId,
                  'type_id': item.typeId,
                  'level_id': item.levelId,
                  'up_id': item.upId,
                  'group_id': item.groupId,
                  'session_id': item.sessionId,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _accountModelDeletionAdapter = DeletionAdapter(
            database,
            'account',
            ['branch_id', 'id'],
            (AccountModel item) => <String, Object?>{
                  'description': item.description,
                  'branch_id': item.branchId,
                  'type_id': item.typeId,
                  'level_id': item.levelId,
                  'up_id': item.upId,
                  'group_id': item.groupId,
                  'session_id': item.sessionId,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<AccountModel> _accountModelInsertionAdapter;

  final UpdateAdapter<AccountModel> _accountModelUpdateAdapter;

  final DeletionAdapter<AccountModel> _accountModelDeletionAdapter;

  @override
  Future<void> insertRow(AccountModel row) async {
    await _accountModelInsertionAdapter.insert(row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<AccountModel> rows) {
    return _accountModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(AccountModel row) async {
    await _accountModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<AccountModel> rows) {
    return _accountModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(AccountModel row) async {
    await _accountModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<AccountModel> rows) {
    return _accountModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$AccountCurrencyDbSet extends AccountCurrencyDbSet {
  _$AccountCurrencyDbSet(
    this.database,
    this.changeListener,
  )   : _accountCurrencyModelInsertionAdapter = InsertionAdapter(
            database,
            'account_currency',
            (AccountCurrencyModel item) => <String, Object?>{
                  'branch_id': item.branchId,
                  'account_id': item.accountId,
                  'currency_id': item.currencyId,
                  'price': item.price,
                  'status': item.status ? 1 : 0,
                  'create_at': _dateTimeConverter.encode(item.createAt),
                  'session_id': item.sessionId,
                  'user_id': item.userId
                }),
        _accountCurrencyModelUpdateAdapter = UpdateAdapter(
            database,
            'account_currency',
            ['branch_id', 'account_id', 'currency_id'],
            (AccountCurrencyModel item) => <String, Object?>{
                  'branch_id': item.branchId,
                  'account_id': item.accountId,
                  'currency_id': item.currencyId,
                  'price': item.price,
                  'status': item.status ? 1 : 0,
                  'create_at': _dateTimeConverter.encode(item.createAt),
                  'session_id': item.sessionId,
                  'user_id': item.userId
                }),
        _accountCurrencyModelDeletionAdapter = DeletionAdapter(
            database,
            'account_currency',
            ['branch_id', 'account_id', 'currency_id'],
            (AccountCurrencyModel item) => <String, Object?>{
                  'branch_id': item.branchId,
                  'account_id': item.accountId,
                  'currency_id': item.currencyId,
                  'price': item.price,
                  'status': item.status ? 1 : 0,
                  'create_at': _dateTimeConverter.encode(item.createAt),
                  'session_id': item.sessionId,
                  'user_id': item.userId
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<AccountCurrencyModel>
      _accountCurrencyModelInsertionAdapter;

  final UpdateAdapter<AccountCurrencyModel> _accountCurrencyModelUpdateAdapter;

  final DeletionAdapter<AccountCurrencyModel>
      _accountCurrencyModelDeletionAdapter;

  @override
  Future<void> insertRow(AccountCurrencyModel row) async {
    await _accountCurrencyModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<AccountCurrencyModel> rows) {
    return _accountCurrencyModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(AccountCurrencyModel row) async {
    await _accountCurrencyModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<AccountCurrencyModel> rows) {
    return _accountCurrencyModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(AccountCurrencyModel row) async {
    await _accountCurrencyModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<AccountCurrencyModel> rows) {
    return _accountCurrencyModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

class _$ReceiptTypeDbSet extends ReceiptTypeDbSet {
  _$ReceiptTypeDbSet(
    this.database,
    this.changeListener,
  )   : _receiptTypeModelInsertionAdapter = InsertionAdapter(
            database,
            'receipt_type',
            (ReceiptTypeModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _receiptTypeModelUpdateAdapter = UpdateAdapter(
            database,
            'receipt_type',
            ['id'],
            (ReceiptTypeModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                }),
        _receiptTypeModelDeletionAdapter = DeletionAdapter(
            database,
            'receipt_type',
            ['id'],
            (ReceiptTypeModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<ReceiptTypeModel> _receiptTypeModelInsertionAdapter;

  final UpdateAdapter<ReceiptTypeModel> _receiptTypeModelUpdateAdapter;

  final DeletionAdapter<ReceiptTypeModel> _receiptTypeModelDeletionAdapter;

  @override
  Future<void> insertRow(ReceiptTypeModel row) async {
    await _receiptTypeModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<ReceiptTypeModel> rows) {
    return _receiptTypeModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(ReceiptTypeModel row) async {
    await _receiptTypeModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<ReceiptTypeModel> rows) {
    return _receiptTypeModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(ReceiptTypeModel row) async {
    await _receiptTypeModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<ReceiptTypeModel> rows) {
    return _receiptTypeModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

class _$ReceiptDbSet extends ReceiptDbSet {
  _$ReceiptDbSet(
    this.database,
    this.changeListener,
  )   : _receiptModelInsertionAdapter = InsertionAdapter(
            database,
            'receipt',
            (ReceiptModel item) => <String, Object?>{
                  'global_no': item.globalNo,
                  'status': item.status ? 1 : 0,
                  'description': item.description,
                  'branch_id': item.branchId,
                  'type_id': item.typeId,
                  'serial_no': item.serialNo,
                  'create_at': _dateTimeConverter.encode(item.createAt),
                  'session_id': item.sessionId,
                  'user_id': item.userId,
                  'id': item.id
                }),
        _receiptModelUpdateAdapter = UpdateAdapter(
            database,
            'receipt',
            ['branch_id', 'type_id', 'id'],
            (ReceiptModel item) => <String, Object?>{
                  'global_no': item.globalNo,
                  'status': item.status ? 1 : 0,
                  'description': item.description,
                  'branch_id': item.branchId,
                  'type_id': item.typeId,
                  'serial_no': item.serialNo,
                  'create_at': _dateTimeConverter.encode(item.createAt),
                  'session_id': item.sessionId,
                  'user_id': item.userId,
                  'id': item.id
                }),
        _receiptModelDeletionAdapter = DeletionAdapter(
            database,
            'receipt',
            ['branch_id', 'type_id', 'id'],
            (ReceiptModel item) => <String, Object?>{
                  'global_no': item.globalNo,
                  'status': item.status ? 1 : 0,
                  'description': item.description,
                  'branch_id': item.branchId,
                  'type_id': item.typeId,
                  'serial_no': item.serialNo,
                  'create_at': _dateTimeConverter.encode(item.createAt),
                  'session_id': item.sessionId,
                  'user_id': item.userId,
                  'id': item.id
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<ReceiptModel> _receiptModelInsertionAdapter;

  final UpdateAdapter<ReceiptModel> _receiptModelUpdateAdapter;

  final DeletionAdapter<ReceiptModel> _receiptModelDeletionAdapter;

  @override
  Future<void> insertRow(ReceiptModel row) async {
    await _receiptModelInsertionAdapter.insert(row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<ReceiptModel> rows) {
    return _receiptModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(ReceiptModel row) async {
    await _receiptModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<ReceiptModel> rows) {
    return _receiptModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(ReceiptModel row) async {
    await _receiptModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<ReceiptModel> rows) {
    return _receiptModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$ReceiptDetailDbSet extends ReceiptDetailDbSet {
  _$ReceiptDetailDbSet(
    this.database,
    this.changeListener,
  )   : _receiptDetailModelInsertionAdapter = InsertionAdapter(
            database,
            'receipt_detail',
            (ReceiptDetailModel item) => <String, Object?>{
                  'description': item.description,
                  'branch_id': item.branchId,
                  'type_id': item.typeId,
                  'receipt_id': item.receiptId,
                  'account_id': item.accountId,
                  'currency_id': item.currencyId,
                  'price': item.price,
                  'session_id': item.sessionId,
                  'user_id': item.userId
                }),
        _receiptDetailModelUpdateAdapter = UpdateAdapter(
            database,
            'receipt_detail',
            ['branch_id', 'type_id', 'receipt_id', 'account_id'],
            (ReceiptDetailModel item) => <String, Object?>{
                  'description': item.description,
                  'branch_id': item.branchId,
                  'type_id': item.typeId,
                  'receipt_id': item.receiptId,
                  'account_id': item.accountId,
                  'currency_id': item.currencyId,
                  'price': item.price,
                  'session_id': item.sessionId,
                  'user_id': item.userId
                }),
        _receiptDetailModelDeletionAdapter = DeletionAdapter(
            database,
            'receipt_detail',
            ['branch_id', 'type_id', 'receipt_id', 'account_id'],
            (ReceiptDetailModel item) => <String, Object?>{
                  'description': item.description,
                  'branch_id': item.branchId,
                  'type_id': item.typeId,
                  'receipt_id': item.receiptId,
                  'account_id': item.accountId,
                  'currency_id': item.currencyId,
                  'price': item.price,
                  'session_id': item.sessionId,
                  'user_id': item.userId
                });

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final InsertionAdapter<ReceiptDetailModel>
      _receiptDetailModelInsertionAdapter;

  final UpdateAdapter<ReceiptDetailModel> _receiptDetailModelUpdateAdapter;

  final DeletionAdapter<ReceiptDetailModel> _receiptDetailModelDeletionAdapter;

  @override
  Future<void> insertRow(ReceiptDetailModel row) async {
    await _receiptDetailModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<ReceiptDetailModel> rows) {
    return _receiptDetailModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(ReceiptDetailModel row) async {
    await _receiptDetailModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<ReceiptDetailModel> rows) {
    return _receiptDetailModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(ReceiptDetailModel row) async {
    await _receiptDetailModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<ReceiptDetailModel> rows) {
    return _receiptDetailModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

class _$StoreDbSet extends StoreDbSet {
  _$StoreDbSet(
    this.database,
    this.changeListener,
  )   : _queryAdapter = QueryAdapter(database, changeListener),
        _storeModelInsertionAdapter = InsertionAdapter(
            database,
            'person',
            (StoreModel item) => <String, Object?>{
                  'description': item.description,
                  'branch_id': item.branchId,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener),
        _storeModelUpdateAdapter = UpdateAdapter(
            database,
            'person',
            ['id'],
            (StoreModel item) => <String, Object?>{
                  'description': item.description,
                  'branch_id': item.branchId,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener),
        _storeModelDeletionAdapter = DeletionAdapter(
            database,
            'person',
            ['id'],
            (StoreModel item) => <String, Object?>{
                  'description': item.description,
                  'branch_id': item.branchId,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener);

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final QueryAdapter _queryAdapter;

  final InsertionAdapter<StoreModel> _storeModelInsertionAdapter;

  final UpdateAdapter<StoreModel> _storeModelUpdateAdapter;

  final DeletionAdapter<StoreModel> _storeModelDeletionAdapter;

  @override
  Future<List<StoreModel>> findAll() async {
    return _queryAdapter.queryList('SELECT * FROM Store',
        mapper: (Map<String, Object?> row) => StoreModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?,
            branchId: row['branch_id'] as int));
  }

  @override
  Stream<StoreModel?> findById(int id) {
    return _queryAdapter.queryStream('SELECT * FROM Store WHERE id = ?1',
        mapper: (Map<String, Object?> row) => StoreModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?,
            branchId: row['branch_id'] as int),
        arguments: [id],
        queryableName: 'Store',
        isView: false);
  }

  @override
  Future<int?> getCount() async {
    return _queryAdapter.query('SELECT COUNT(id) FROM Store',
        mapper: (Map<String, Object?> row) => row.values.first as int);
  }

  @override
  Future<List<StoreModel>> findByBranchIds(List<int> branchIds) async {
    const offset = 1;
    final _sqliteVariablesForBranchIds =
        Iterable<String>.generate(branchIds.length, (i) => '?${i + offset}')
            .join(',');
    return _queryAdapter.queryList(
        'SELECT * FROM Store WHERE branch_id IN (' +
            _sqliteVariablesForBranchIds +
            ')',
        mapper: (Map<String, Object?> row) => StoreModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?,
            branchId: row['branch_id'] as int),
        arguments: [...branchIds]);
  }

  @override
  Future<void> insertRow(StoreModel row) async {
    await _storeModelInsertionAdapter.insert(row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<StoreModel> rows) {
    return _storeModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(StoreModel row) async {
    await _storeModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<StoreModel> rows) {
    return _storeModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(StoreModel row) async {
    await _storeModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<StoreModel> rows) {
    return _storeModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$ProductCatagoryDbSet extends ProductCatagoryDbSet {
  _$ProductCatagoryDbSet(
    this.database,
    this.changeListener,
  )   : _queryAdapter = QueryAdapter(database, changeListener),
        _productCatagoryModelInsertionAdapter = InsertionAdapter(
            database,
            'product_catagory',
            (ProductCatagoryModel item) => <String, Object?>{
                  'description': item.description,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener),
        _productCatagoryModelUpdateAdapter = UpdateAdapter(
            database,
            'product_catagory',
            ['id'],
            (ProductCatagoryModel item) => <String, Object?>{
                  'description': item.description,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener),
        _productCatagoryModelDeletionAdapter = DeletionAdapter(
            database,
            'product_catagory',
            ['id'],
            (ProductCatagoryModel item) => <String, Object?>{
                  'description': item.description,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener);

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final QueryAdapter _queryAdapter;

  final InsertionAdapter<ProductCatagoryModel>
      _productCatagoryModelInsertionAdapter;

  final UpdateAdapter<ProductCatagoryModel> _productCatagoryModelUpdateAdapter;

  final DeletionAdapter<ProductCatagoryModel>
      _productCatagoryModelDeletionAdapter;

  @override
  Future<List<ProductCatagoryModel>> findAll() async {
    return _queryAdapter.queryList(
        'SELECT * FROM product_catagory WHERE status = 1',
        mapper: (Map<String, Object?> row) => ProductCatagoryModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?));
  }

  @override
  Stream<List<ProductCatagoryModel>> findAllAsStream() {
    return _queryAdapter.queryListStream(
        'SELECT * FROM product_catagory WHERE status = 1',
        mapper: (Map<String, Object?> row) => ProductCatagoryModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?),
        queryableName: 'product_catagory',
        isView: false);
  }

  @override
  Future<ProductCatagoryModel?> findById(int id) async {
    return _queryAdapter.query('SELECT * FROM product_catagory WHERE id = ?1',
        mapper: (Map<String, Object?> row) => ProductCatagoryModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?),
        arguments: [id]);
  }

  @override
  Stream<ProductCatagoryModel?> findByIdAsStream(int id) {
    return _queryAdapter.queryStream(
        'SELECT * FROM product_catagory WHERE id = ?1',
        mapper: (Map<String, Object?> row) => ProductCatagoryModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?),
        arguments: [id],
        queryableName: 'product_catagory',
        isView: false);
  }

  @override
  Future<int?> getCount() async {
    return _queryAdapter.query(
        'SELECT count(*) FROM product_catagory WHERE status = 1',
        mapper: (Map<String, Object?> row) => row.values.first as int);
  }

  @override
  Future<void> insertRow(ProductCatagoryModel row) async {
    await _productCatagoryModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<ProductCatagoryModel> rows) {
    return _productCatagoryModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(ProductCatagoryModel row) async {
    await _productCatagoryModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<ProductCatagoryModel> rows) {
    return _productCatagoryModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(ProductCatagoryModel row) async {
    await _productCatagoryModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<ProductCatagoryModel> rows) {
    return _productCatagoryModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

class _$MeasureUnitDbSet extends MeasureUnitDbSet {
  _$MeasureUnitDbSet(
    this.database,
    this.changeListener,
  )   : _queryAdapter = QueryAdapter(database, changeListener),
        _measureUnitModelInsertionAdapter = InsertionAdapter(
            database,
            'measure_unit',
            (MeasureUnitModel item) => <String, Object?>{
                  'description': item.description,
                  'up_id': item.upId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener),
        _measureUnitModelUpdateAdapter = UpdateAdapter(
            database,
            'measure_unit',
            ['id'],
            (MeasureUnitModel item) => <String, Object?>{
                  'description': item.description,
                  'up_id': item.upId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener),
        _measureUnitModelDeletionAdapter = DeletionAdapter(
            database,
            'measure_unit',
            ['id'],
            (MeasureUnitModel item) => <String, Object?>{
                  'description': item.description,
                  'up_id': item.upId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener);

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final QueryAdapter _queryAdapter;

  final InsertionAdapter<MeasureUnitModel> _measureUnitModelInsertionAdapter;

  final UpdateAdapter<MeasureUnitModel> _measureUnitModelUpdateAdapter;

  final DeletionAdapter<MeasureUnitModel> _measureUnitModelDeletionAdapter;

  @override
  Future<List<MeasureUnitModel>> findAll() async {
    return _queryAdapter.queryList(
        'SELECT * FROM measure_unit WHERE status = 1',
        mapper: (Map<String, Object?> row) => MeasureUnitModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?,
            upId: row['up_id'] as int?));
  }

  @override
  Stream<List<MeasureUnitModel>> findAllAsStream() {
    return _queryAdapter.queryListStream(
        'SELECT * FROM measure_unit WHERE status = 1',
        mapper: (Map<String, Object?> row) => MeasureUnitModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?,
            upId: row['up_id'] as int?),
        queryableName: 'measure_unit',
        isView: false);
  }

  @override
  Future<MeasureUnitModel?> findById(int id) async {
    return _queryAdapter.query('SELECT * FROM measure_unit WHERE id = ?1',
        mapper: (Map<String, Object?> row) => MeasureUnitModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?,
            upId: row['up_id'] as int?),
        arguments: [id]);
  }

  @override
  Stream<MeasureUnitModel?> findByIdAsStream(int id) {
    return _queryAdapter.queryStream('SELECT * FROM measure_unit WHERE id = ?1',
        mapper: (Map<String, Object?> row) => MeasureUnitModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?,
            upId: row['up_id'] as int?),
        arguments: [id],
        queryableName: 'measure_unit',
        isView: false);
  }

  @override
  Future<int?> getCount() async {
    return _queryAdapter.query(
        'SELECT count(*) FROM measure_unit WHERE status = 1',
        mapper: (Map<String, Object?> row) => row.values.first as int);
  }

  @override
  Future<List<MeasureUnitModel>> findByUpId(int upId) async {
    return _queryAdapter.queryList(
        'SELECT * FROM measure_unit WHERE up_id = ?1 and status = 1',
        mapper: (Map<String, Object?> row) => MeasureUnitModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?,
            upId: row['up_id'] as int?),
        arguments: [upId]);
  }

  @override
  Stream<List<MeasureUnitModel>> findByUpIdAsStream(int upId) {
    return _queryAdapter.queryListStream(
        'SELECT * FROM measure_unit WHERE up_id = ?1 and status = 1',
        mapper: (Map<String, Object?> row) => MeasureUnitModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?,
            upId: row['up_id'] as int?),
        arguments: [upId],
        queryableName: 'measure_unit',
        isView: false);
  }

  @override
  Future<int?> getCountByUpId(int upId) async {
    return _queryAdapter.query(
        'SELECT count(*) FROM measure_unit WHERE up_id = ?1 and status = 1',
        mapper: (Map<String, Object?> row) => row.values.first as int,
        arguments: [upId]);
  }

  @override
  Future<void> insertRow(MeasureUnitModel row) async {
    await _measureUnitModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<MeasureUnitModel> rows) {
    return _measureUnitModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(MeasureUnitModel row) async {
    await _measureUnitModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<MeasureUnitModel> rows) {
    return _measureUnitModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(MeasureUnitModel row) async {
    await _measureUnitModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<MeasureUnitModel> rows) {
    return _measureUnitModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

class _$ProductTypeDbSet extends ProductTypeDbSet {
  _$ProductTypeDbSet(
    this.database,
    this.changeListener,
  )   : _queryAdapter = QueryAdapter(database, changeListener),
        _productTypeModelInsertionAdapter = InsertionAdapter(
            database,
            'product_type',
            (ProductTypeModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener),
        _productTypeModelUpdateAdapter = UpdateAdapter(
            database,
            'product_type',
            ['id'],
            (ProductTypeModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener),
        _productTypeModelDeletionAdapter = DeletionAdapter(
            database,
            'product_type',
            ['id'],
            (ProductTypeModel item) => <String, Object?>{
                  'description': item.description,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener);

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final QueryAdapter _queryAdapter;

  final InsertionAdapter<ProductTypeModel> _productTypeModelInsertionAdapter;

  final UpdateAdapter<ProductTypeModel> _productTypeModelUpdateAdapter;

  final DeletionAdapter<ProductTypeModel> _productTypeModelDeletionAdapter;

  @override
  Future<List<ProductTypeModel>> findAll() async {
    return _queryAdapter.queryList(
        'SELECT * FROM product_type WHERE status = 1',
        mapper: (Map<String, Object?> row) => ProductTypeModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?));
  }

  @override
  Future<ProductTypeModel?> findById(int id) async {
    return _queryAdapter.query('SELECT * FROM product_type WHERE id = ?1',
        mapper: (Map<String, Object?> row) => ProductTypeModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?),
        arguments: [id]);
  }

  @override
  Stream<ProductTypeModel?> findByIdAsStream(int id) {
    return _queryAdapter.queryStream('SELECT * FROM product_type WHERE id = ?1',
        mapper: (Map<String, Object?> row) => ProductTypeModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            description: row['description'] as String?),
        arguments: [id],
        queryableName: 'product_type',
        isView: false);
  }

  @override
  Future<int?> getCount() async {
    return _queryAdapter.query(
        'SELECT COUNT(id) FROM product_type WHERE status = 1',
        mapper: (Map<String, Object?> row) => row.values.first as int);
  }

  @override
  Future<void> insertRow(ProductTypeModel row) async {
    await _productTypeModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<ProductTypeModel> rows) {
    return _productTypeModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(ProductTypeModel row) async {
    await _productTypeModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<ProductTypeModel> rows) {
    return _productTypeModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(ProductTypeModel row) async {
    await _productTypeModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<ProductTypeModel> rows) {
    return _productTypeModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

class _$ProductDbSet extends ProductDbSet {
  _$ProductDbSet(
    this.database,
    this.changeListener,
  )   : _queryAdapter = QueryAdapter(database, changeListener),
        _productModelInsertionAdapter = InsertionAdapter(
            database,
            'product',
            (ProductModel item) => <String, Object?>{
                  'catagory_id': item.catagoryId,
                  'type_id': item.typeId,
                  'measure_unit_id': item.measureUnitId,
                  'description': item.description,
                  'second_name': item.secondName,
                  'images': _listStringNullSafetyConverter.encode(item.images),
                  'has_expire_date': item.hasExpireDate ? 1 : 0,
                  'age_days': item.ageDays,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener),
        _productModelUpdateAdapter = UpdateAdapter(
            database,
            'product',
            ['id'],
            (ProductModel item) => <String, Object?>{
                  'catagory_id': item.catagoryId,
                  'type_id': item.typeId,
                  'measure_unit_id': item.measureUnitId,
                  'description': item.description,
                  'second_name': item.secondName,
                  'images': _listStringNullSafetyConverter.encode(item.images),
                  'has_expire_date': item.hasExpireDate ? 1 : 0,
                  'age_days': item.ageDays,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener),
        _productModelDeletionAdapter = DeletionAdapter(
            database,
            'product',
            ['id'],
            (ProductModel item) => <String, Object?>{
                  'catagory_id': item.catagoryId,
                  'type_id': item.typeId,
                  'measure_unit_id': item.measureUnitId,
                  'description': item.description,
                  'second_name': item.secondName,
                  'images': _listStringNullSafetyConverter.encode(item.images),
                  'has_expire_date': item.hasExpireDate ? 1 : 0,
                  'age_days': item.ageDays,
                  'user_id': item.userId,
                  'name': item.name,
                  'status': item.status ? 1 : 0,
                  'id': item.id
                },
            changeListener);

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final QueryAdapter _queryAdapter;

  final InsertionAdapter<ProductModel> _productModelInsertionAdapter;

  final UpdateAdapter<ProductModel> _productModelUpdateAdapter;

  final DeletionAdapter<ProductModel> _productModelDeletionAdapter;

  @override
  Future<List<ProductModel>> findAll() async {
    return _queryAdapter.queryList('SELECT * FROM Product WHERE status = 1',
        mapper: (Map<String, Object?> row) => ProductModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            catagoryId: row['catagory_id'] as int,
            typeId: row['type_id'] as int,
            measureUnitId: row['measure_unit_id'] as int?,
            description: row['description'] as String?,
            images:
                _listStringNullSafetyConverter.decode(row['images'] as String?),
            secondName: row['second_name'] as String?,
            hasExpireDate: (row['has_expire_date'] as int) != 0,
            ageDays: row['age_days'] as int?));
  }

  @override
  Stream<List<ProductModel>> findAllAsStream() {
    return _queryAdapter.queryListStream(
        'SELECT * FROM Product WHERE status = 1',
        mapper: (Map<String, Object?> row) => ProductModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            catagoryId: row['catagory_id'] as int,
            typeId: row['type_id'] as int,
            measureUnitId: row['measure_unit_id'] as int?,
            description: row['description'] as String?,
            images:
                _listStringNullSafetyConverter.decode(row['images'] as String?),
            secondName: row['second_name'] as String?,
            hasExpireDate: (row['has_expire_date'] as int) != 0,
            ageDays: row['age_days'] as int?),
        queryableName: 'Product',
        isView: false);
  }

  @override
  Future<int?> getCount() async {
    return _queryAdapter.query('SELECT count(*) FROM Product WHERE status = 1',
        mapper: (Map<String, Object?> row) => row.values.first as int);
  }

  @override
  Future<List<ProductModel>> findBy(
    int catagoryId,
    int typeId,
    int measureUnitId,
  ) async {
    return _queryAdapter.queryList(
        'SELECT * FROM Product WHERE        (0 = ?1 or catagory_id = ?1) and        (0 = ?2 or type_id = ?2) and        (0 = ?3 or measure_unit_id = ?3) and         status = 1',
        mapper: (Map<String, Object?> row) => ProductModel(id: row['id'] as int, name: row['name'] as String, status: (row['status'] as int) != 0, catagoryId: row['catagory_id'] as int, typeId: row['type_id'] as int, measureUnitId: row['measure_unit_id'] as int?, description: row['description'] as String?, images: _listStringNullSafetyConverter.decode(row['images'] as String?), secondName: row['second_name'] as String?, hasExpireDate: (row['has_expire_date'] as int) != 0, ageDays: row['age_days'] as int?),
        arguments: [catagoryId, typeId, measureUnitId]);
  }

  @override
  Stream<List<ProductModel>> findByAsStream(
    int catagoryId,
    int typeId,
    int measureUnitId,
  ) {
    return _queryAdapter.queryListStream(
        'SELECT * FROM Product WHERE        (0 = ?1 or catagory_id = ?1) and        (0 = ?2 or type_id = ?2) and        (0 = ?3 or measure_unit_id = ?3) and         status = 1',
        mapper: (Map<String, Object?> row) => ProductModel(
            id: row['id'] as int,
            name: row['name'] as String,
            status: (row['status'] as int) != 0,
            catagoryId: row['catagory_id'] as int,
            typeId: row['type_id'] as int,
            measureUnitId: row['measure_unit_id'] as int?,
            description: row['description'] as String?,
            images:
                _listStringNullSafetyConverter.decode(row['images'] as String?),
            secondName: row['second_name'] as String?,
            hasExpireDate: (row['has_expire_date'] as int) != 0,
            ageDays: row['age_days'] as int?),
        arguments: [catagoryId, typeId, measureUnitId],
        queryableName: 'Product',
        isView: false);
  }

  @override
  Future<int?> getCountBy(
    int catagoryId,
    int typeId,
    int measureUnitId,
  ) async {
    return _queryAdapter.query(
        'SELECT count(*) FROM Product WHERE        (0 = ?1 or catagory_id = ?1) and        (0 = ?2 or type_id = ?2) and        (0 = ?3 or measure_unit_id = ?3) and         status = 1',
        mapper: (Map<String, Object?> row) => row.values.first as int,
        arguments: [catagoryId, typeId, measureUnitId]);
  }

  @override
  Future<void> insertRow(ProductModel row) async {
    await _productModelInsertionAdapter.insert(row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<ProductModel> rows) {
    return _productModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(ProductModel row) async {
    await _productModelUpdateAdapter.update(row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<ProductModel> rows) {
    return _productModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(ProductModel row) async {
    await _productModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<ProductModel> rows) {
    return _productModelDeletionAdapter.deleteListAndReturnChangedRows(rows);
  }
}

class _$ProductMeasureDbSet extends ProductMeasureDbSet {
  _$ProductMeasureDbSet(
    this.database,
    this.changeListener,
  )   : _queryAdapter = QueryAdapter(database, changeListener),
        _productMeasureModelInsertionAdapter = InsertionAdapter(
            database,
            'product_measure',
            (ProductMeasureModel item) => <String, Object?>{
                  'product_id': item.productId,
                  'measure_unit_id': item.measureUnitId,
                  'currency_id': item.currencyId,
                  'price': item.price,
                  'status': item.status ? 1 : 0,
                  'barcode': item.barcode,
                  'min_count': item.minCount,
                  'max_count': item.maxCount,
                  'notify_count': item.notifyCount,
                  'session_id': item.sessionId,
                  'user_id': item.userId
                },
            changeListener),
        _productMeasureModelUpdateAdapter = UpdateAdapter(
            database,
            'product_measure',
            ['product_id', 'measure_unit_id', 'currency_id'],
            (ProductMeasureModel item) => <String, Object?>{
                  'product_id': item.productId,
                  'measure_unit_id': item.measureUnitId,
                  'currency_id': item.currencyId,
                  'price': item.price,
                  'status': item.status ? 1 : 0,
                  'barcode': item.barcode,
                  'min_count': item.minCount,
                  'max_count': item.maxCount,
                  'notify_count': item.notifyCount,
                  'session_id': item.sessionId,
                  'user_id': item.userId
                },
            changeListener),
        _productMeasureModelDeletionAdapter = DeletionAdapter(
            database,
            'product_measure',
            ['product_id', 'measure_unit_id', 'currency_id'],
            (ProductMeasureModel item) => <String, Object?>{
                  'product_id': item.productId,
                  'measure_unit_id': item.measureUnitId,
                  'currency_id': item.currencyId,
                  'price': item.price,
                  'status': item.status ? 1 : 0,
                  'barcode': item.barcode,
                  'min_count': item.minCount,
                  'max_count': item.maxCount,
                  'notify_count': item.notifyCount,
                  'session_id': item.sessionId,
                  'user_id': item.userId
                },
            changeListener);

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final QueryAdapter _queryAdapter;

  final InsertionAdapter<ProductMeasureModel>
      _productMeasureModelInsertionAdapter;

  final UpdateAdapter<ProductMeasureModel> _productMeasureModelUpdateAdapter;

  final DeletionAdapter<ProductMeasureModel>
      _productMeasureModelDeletionAdapter;

  @override
  Future<List<ProductMeasureModel>> findAll() async {
    return _queryAdapter.queryList(
        'SELECT * FROM product_measure WHERE status = 1',
        mapper: (Map<String, Object?> row) => ProductMeasureModel(
            productId: row['product_id'] as int,
            measureUnitId: row['measure_unit_id'] as int,
            currencyId: row['currency_id'] as int,
            price: row['price'] as double,
            status: (row['status'] as int) != 0,
            barcode: row['barcode'] as String?,
            minCount: row['min_count'] as int,
            maxCount: row['max_count'] as int?,
            notifyCount: row['notify_count'] as int?));
  }

  @override
  Stream<List<ProductMeasureModel>> findAllAsStream() {
    return _queryAdapter.queryListStream(
        'SELECT * FROM product_measure WHERE status = 1',
        mapper: (Map<String, Object?> row) => ProductMeasureModel(
            productId: row['product_id'] as int,
            measureUnitId: row['measure_unit_id'] as int,
            currencyId: row['currency_id'] as int,
            price: row['price'] as double,
            status: (row['status'] as int) != 0,
            barcode: row['barcode'] as String?,
            minCount: row['min_count'] as int,
            maxCount: row['max_count'] as int?,
            notifyCount: row['notify_count'] as int?),
        queryableName: 'product_measure',
        isView: false);
  }

  @override
  Future<List<ProductMeasureModel>> findBy(
    int productId,
    int currencyId,
  ) async {
    return _queryAdapter.queryList(
        'SELECT * FROM product_measure WHERE        (0 = ?1 or product_id = ?1) and        (0 = ?2 or currency_id = ?2) and status = 1',
        mapper: (Map<String, Object?> row) => ProductMeasureModel(productId: row['product_id'] as int, measureUnitId: row['measure_unit_id'] as int, currencyId: row['currency_id'] as int, price: row['price'] as double, status: (row['status'] as int) != 0, barcode: row['barcode'] as String?, minCount: row['min_count'] as int, maxCount: row['max_count'] as int?, notifyCount: row['notify_count'] as int?),
        arguments: [productId, currencyId]);
  }

  @override
  Stream<List<ProductMeasureModel>> findByAsStream(
    int productId,
    int currencyId,
  ) {
    return _queryAdapter.queryListStream(
        'SELECT * FROM product_measure WHERE        (0 = ?1 or product_id = ?1) and        (0 = ?2 or currency_id = ?2) and status = 1',
        mapper: (Map<String, Object?> row) => ProductMeasureModel(
            productId: row['product_id'] as int,
            measureUnitId: row['measure_unit_id'] as int,
            currencyId: row['currency_id'] as int,
            price: row['price'] as double,
            status: (row['status'] as int) != 0,
            barcode: row['barcode'] as String?,
            minCount: row['min_count'] as int,
            maxCount: row['max_count'] as int?,
            notifyCount: row['notify_count'] as int?),
        arguments: [productId, currencyId],
        queryableName: 'product_measure',
        isView: false);
  }

  @override
  Future<int?> getCount(
    int productId,
    int currencyId,
  ) async {
    return _queryAdapter.query(
        'SELECT count(*) FROM product_measure WHERE        (0 = ?1 or product_id = ?1) and        (0 = ?2 or currency_id = ?2) and status = 1',
        mapper: (Map<String, Object?> row) => row.values.first as int,
        arguments: [productId, currencyId]);
  }

  @override
  Future<void> insertRow(ProductMeasureModel row) async {
    await _productMeasureModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<ProductMeasureModel> rows) {
    return _productMeasureModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(ProductMeasureModel row) async {
    await _productMeasureModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<ProductMeasureModel> rows) {
    return _productMeasureModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(ProductMeasureModel row) async {
    await _productMeasureModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<ProductMeasureModel> rows) {
    return _productMeasureModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

class _$ProductStorageDbSet extends ProductStorageDbSet {
  _$ProductStorageDbSet(
    this.database,
    this.changeListener,
  )   : _queryAdapter = QueryAdapter(database, changeListener),
        _productStorageModelInsertionAdapter = InsertionAdapter(
            database,
            'product_storage',
            (ProductStorageModel item) => <String, Object?>{
                  'branch_id': item.branchId,
                  'product_id': item.productId,
                  'measure_unit_id': item.measureUnitId,
                  'currency_id': item.currencyId,
                  'store_id': item.storeId,
                  'price': item.price,
                  'expired_at': _dateTimeConverter.encode(item.expiredAt),
                  'produced_at':
                      _dateTimeNullSafetyConverter.encode(item.producedAt),
                  'count': item.count
                },
            changeListener),
        _productStorageModelUpdateAdapter = UpdateAdapter(
            database,
            'product_storage',
            [
              'branch_id',
              'product_id',
              'measure_unit_id',
              'currency_id',
              'store_id',
              'price',
              'expired_at'
            ],
            (ProductStorageModel item) => <String, Object?>{
                  'branch_id': item.branchId,
                  'product_id': item.productId,
                  'measure_unit_id': item.measureUnitId,
                  'currency_id': item.currencyId,
                  'store_id': item.storeId,
                  'price': item.price,
                  'expired_at': _dateTimeConverter.encode(item.expiredAt),
                  'produced_at':
                      _dateTimeNullSafetyConverter.encode(item.producedAt),
                  'count': item.count
                },
            changeListener),
        _productStorageModelDeletionAdapter = DeletionAdapter(
            database,
            'product_storage',
            [
              'branch_id',
              'product_id',
              'measure_unit_id',
              'currency_id',
              'store_id',
              'price',
              'expired_at'
            ],
            (ProductStorageModel item) => <String, Object?>{
                  'branch_id': item.branchId,
                  'product_id': item.productId,
                  'measure_unit_id': item.measureUnitId,
                  'currency_id': item.currencyId,
                  'store_id': item.storeId,
                  'price': item.price,
                  'expired_at': _dateTimeConverter.encode(item.expiredAt),
                  'produced_at':
                      _dateTimeNullSafetyConverter.encode(item.producedAt),
                  'count': item.count
                },
            changeListener);

  final sqflite.DatabaseExecutor database;

  final StreamController<String> changeListener;

  final QueryAdapter _queryAdapter;

  final InsertionAdapter<ProductStorageModel>
      _productStorageModelInsertionAdapter;

  final UpdateAdapter<ProductStorageModel> _productStorageModelUpdateAdapter;

  final DeletionAdapter<ProductStorageModel>
      _productStorageModelDeletionAdapter;

  @override
  Future<List<ProductStorageModel>> findAll() async {
    return _queryAdapter.queryList('SELECT * FROM product_storage',
        mapper: (Map<String, Object?> row) => ProductStorageModel(
            branchId: row['branch_id'] as int,
            productId: row['product_id'] as int,
            measureUnitId: row['measure_unit_id'] as int,
            currencyId: row['currency_id'] as int,
            storeId: row['store_id'] as int,
            price: row['price'] as double,
            expiredAt: _dateTimeConverter.decode(row['expired_at'] as int),
            producedAt:
                _dateTimeNullSafetyConverter.decode(row['produced_at'] as int?),
            count: row['count'] as int));
  }

  @override
  Stream<List<ProductStorageModel>> findAllAsStream() {
    return _queryAdapter.queryListStream('SELECT * FROM product_storage',
        mapper: (Map<String, Object?> row) => ProductStorageModel(
            branchId: row['branch_id'] as int,
            productId: row['product_id'] as int,
            measureUnitId: row['measure_unit_id'] as int,
            currencyId: row['currency_id'] as int,
            storeId: row['store_id'] as int,
            price: row['price'] as double,
            expiredAt: _dateTimeConverter.decode(row['expired_at'] as int),
            producedAt:
                _dateTimeNullSafetyConverter.decode(row['produced_at'] as int?),
            count: row['count'] as int),
        queryableName: 'product_storage',
        isView: false);
  }

  @override
  Future<List<ProductStorageModel>> findBy(
    int productId,
    int branchId,
    int storeId,
    int currencyId,
  ) async {
    return _queryAdapter.queryList(
        'SELECT * FROM product_storage WHERE        (0 = ?1 or product_id = ?1) and        (0 = ?2 or branch_id = ?2) and        (0 = ?3 or store_id = ?3) and        (0 = ?4 or currency_id = ?4)',
        mapper: (Map<String, Object?> row) => ProductStorageModel(branchId: row['branch_id'] as int, productId: row['product_id'] as int, measureUnitId: row['measure_unit_id'] as int, currencyId: row['currency_id'] as int, storeId: row['store_id'] as int, price: row['price'] as double, expiredAt: _dateTimeConverter.decode(row['expired_at'] as int), producedAt: _dateTimeNullSafetyConverter.decode(row['produced_at'] as int?), count: row['count'] as int),
        arguments: [productId, branchId, storeId, currencyId]);
  }

  @override
  Stream<List<ProductStorageModel>> findByAsStream(
    int productId,
    int branchId,
    int storeId,
    int currencyId,
  ) {
    return _queryAdapter.queryListStream(
        'SELECT * FROM product_storage WHERE        (0 = ?1 or product_id = ?1) and        (0 = ?2 or branch_id = ?2) and        (0 = ?3 or store_id = ?3) and        (0 = ?4 or currency_id = ?4)',
        mapper: (Map<String, Object?> row) => ProductStorageModel(
            branchId: row['branch_id'] as int,
            productId: row['product_id'] as int,
            measureUnitId: row['measure_unit_id'] as int,
            currencyId: row['currency_id'] as int,
            storeId: row['store_id'] as int,
            price: row['price'] as double,
            expiredAt: _dateTimeConverter.decode(row['expired_at'] as int),
            producedAt:
                _dateTimeNullSafetyConverter.decode(row['produced_at'] as int?),
            count: row['count'] as int),
        arguments: [productId, branchId, storeId, currencyId],
        queryableName: 'product_storage',
        isView: false);
  }

  @override
  Future<int?> sumOf(
    int productId,
    int branchId,
    int storeId,
    int currencyId,
  ) async {
    return _queryAdapter.query(
        'SELECT sum(count) FROM product_storage WHERE        (0 = ?1 or product_id = ?1) and        (0 = ?2 or branch_id = ?2) and        (0 = ?3 or store_id = ?3) and        (0 = ?4 or currency_id = ?4)',
        mapper: (Map<String, Object?> row) => row.values.first as int,
        arguments: [productId, branchId, storeId, currencyId]);
  }

  @override
  Future<void> insertRow(ProductStorageModel row) async {
    await _productStorageModelInsertionAdapter.insert(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<List<int>> insertRows(List<ProductStorageModel> rows) {
    return _productStorageModelInsertionAdapter.insertListAndReturnIds(
        rows, OnConflictStrategy.replace);
  }

  @override
  Future<void> updateRow(ProductStorageModel row) async {
    await _productStorageModelUpdateAdapter.update(
        row, OnConflictStrategy.replace);
  }

  @override
  Future<int> updateRows(List<ProductStorageModel> rows) {
    return _productStorageModelUpdateAdapter.updateListAndReturnChangedRows(
        rows, OnConflictStrategy.abort);
  }

  @override
  Future<void> deleteRow(ProductStorageModel row) async {
    await _productStorageModelDeletionAdapter.delete(row);
  }

  @override
  Future<int> deleteRows(List<ProductStorageModel> rows) {
    return _productStorageModelDeletionAdapter
        .deleteListAndReturnChangedRows(rows);
  }
}

// ignore_for_file: unused_element
final _dateTimeConverter = DateTimeConverter();
final _dateTimeNullSafetyConverter = DateTimeNullSafetyConverter();
final _listStringConverter = ListStringConverter();
final _listStringNullSafetyConverter = ListStringNullSafetyConverter();
