part of '../../../permission_management.dart';

@Entity(tableName: 'user', primaryKeys: ['id'])
class UserModel extends IdentityModel {
  @ColumnInfo(name: 'name')
  final String name;
  static const String nameTag = "name";

  @ColumnInfo(name: 'create_at')
  final DateTime createAt;
  static const String createAtTag = "createAt";

  @ColumnInfo(name: 'session_id')
  final int sessionId;
  static const String sessionIdTag = "sessionId";

  UserModel({
    super.id = 0,
    required this.name,
  })  : createAt = DateTime.now(),
        sessionId = 0;
  UserModel.fromMap(super.map)
      : name = map.getString(nameTag)!,
        createAt = map.getDateTime(createAtTag)!,
        sessionId = map.getInt(sessionIdTag)!,
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        nameTag: name,
      };
}

extension UserModelExtension<ModelType extends UserModel>
    on Iterable<ModelType> {}
