part of '../../public.dart';

abstract class ModelDbSet<ModelType extends Model> {
  @Insert(onConflict: OnConflictStrategy.replace)
  Future<void> insertRow(ModelType row);

  @Insert(onConflict: OnConflictStrategy.replace)
  Future<List<int>> insertRows(List<ModelType> rows);

  @Update(onConflict: OnConflictStrategy.replace)
  Future<void> updateRow(ModelType row);

  @update
  Future<int> updateRows(List<ModelType> rows);

  @delete
  Future<void> deleteRow(ModelType row);

  @delete
  Future<int> deleteRows(List<ModelType> rows);
}
