part of '../../../store_management.dart';

@Entity(tableName: 'product_catagory', primaryKeys: ['id'])
class ProductCatagoryModel extends NameModel {
  final String? description;
  static const String descriptionTag = "description";

  @ColumnInfo(name: 'user_id')
  final int userId;
  static const String userIdTag = "userId";

  const ProductCatagoryModel({
    super.id = 0,
    required super.name,
    super.status = true,
    this.description,
  }) : userId = 0;
  ProductCatagoryModel.fromMap(super.map)
      : description = map.getString(descriptionTag),
        userId = map.getInt(userIdTag)!,
        super.fromMap();

  @override
  Map<String, dynamic> toMap() =>
      {...super.toMap(), descriptionTag: description};
}
