part of '../../../store_management.dart';

@Entity(
  tableName: 'person',
  primaryKeys: ['id', 'branchId'],
  foreignKeys: [
    ForeignKey(
      childColumns: ['branch_id'],
      parentColumns: ['id'],
      entity: BranchModel,
    ),
  ],
)
class StoreModel extends NameModel {
  final String? description;
  static const String descriptionTag = "description";

  @ColumnInfo(name: 'branch_id')
  final int branchId;
  static const String branchIdTag = "branchId";

  @ColumnInfo(name: 'user_id')
  final int userId;
  static const String userIdTag = "userId";

  const StoreModel({
    super.id = 0,
    required super.name,
    super.status = true,
    this.description,
    required this.branchId,
  }) : userId = 0;

  StoreModel.fromMap(super.map)
      : description = map.getString(descriptionTag),
        branchId = map.getInt(branchIdTag)!,
        userId = map.getInt(userIdTag)!,
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        descriptionTag: description,
        branchIdTag: branchId,
      };
}
